<?php

namespace Kahanit\TableRateShipping\Block;

// inheritance
use Magento\Framework\View\Element\Template;
// injection
use Magento\Framework\View\Element\Template\Context;
use Magento\Framework\Json\Encoder;
use Magento\Framework\Data\Form\FormKey;
use Kahanit\TableRateShipping\Model\ResourceModel\CarrierTableRateMethod;
use Kahanit\TableRateShipping\Model\ResourceModel\CarrierTableRateZone;
// other
use Magento\Framework\Module\Dir;
use Magento\Store\Model\Store;

class TableRateShippingAdmin extends Template
{
    protected $jsonEncoder;

    protected $formKey;

    protected $carrierTableRateMethodModel;

    protected $carrierTableRateZoneModel;

    public function __construct(
        Context $context,
        Encoder $jsonEncoder,
        FormKey $formKey,
        CarrierTableRateMethod $carrierTableRateMethodModel,
        CarrierTableRateZone $carrierTableRateZoneModel
    )
    {
        $this->jsonEncoder = $jsonEncoder;
        $this->formKey = $formKey;
        $this->carrierTableRateMethodModel = $carrierTableRateMethodModel;
        $this->carrierTableRateZoneModel = $carrierTableRateZoneModel;

        parent::__construct($context);
    }

    public function tableRateShippingMageInit()
    {
        return $this->jsonEncoder->encode(
            (object)[
                'jquery.admintablerateshipping.loader' => (object)[
                    'url' => $this->getUrl(
                            'tablerateshipping/index/ajax', [
                                'store' => $this->getRequest()->getParam('store', Store::DEFAULT_STORE_ID),
                                'form_key' => $this->formKey->getFormKey()
                            ]
                        ) . '?isAjax=true'
                ]
            ]
        );
    }

    public function getCarriers()
    {
        $id_shop = $this->getRequest()->getParam('store', Store::DEFAULT_STORE_ID);

        return $this->carrierTableRateMethodModel->getCarriers($id_shop);
    }

    public function getZones()
    {
        $id_shop = $this->getRequest()->getParam('store', Store::DEFAULT_STORE_ID);

        return $this->carrierTableRateZoneModel->getZones($id_shop);
    }
}
