<?php

namespace Kahanit\TableRateShipping\Helper;

/**
 * Class TRSCSV
 *
 * @package Kahanit\TableRateShipping\Helper
 */
class TRSCSV
{
    public $filename;

    public $collection;

    public $delimiter;

    public function __construct($collection, $filename, $delimiter = ';')
    {
        $this->filename = $filename;
        $this->delimiter = $delimiter;
        $this->collection = $collection;
    }

    public function export()
    {
        $this->headers();

        $header_line = false;

        foreach ($this->collection as $object) {
            $vars = get_object_vars($object);
            if (!$header_line) {
                $this->output(array_keys($vars));
                $header_line = true;
            }

            // outputs values
            $this->output($vars);
            unset($vars);
        }
    }

    public function output($data)
    {
        $wraped_data = array_map(array($this, 'wrap'), $data);
        echo sprintf("%s\n", implode($this->delimiter, $wraped_data));
    }

    public static function wrap($data)
    {
        $data = str_replace(array('"', ';'), '', $data);

        return sprintf('"%s"', $data);
    }

    public function headers()
    {
        header('Content-type: text/csv');
        header('Content-Type: application/force-download; charset=UTF-8');
        header('Cache-Control: no-store, no-cache');
        header('Content-disposition: attachment; filename="' . $this->filename . '.csv"');
    }
}