<?php

namespace Kahanit\TableRateShipping\Model;

// inheritance
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\DataObject\IdentityInterface;

class CarrierTableRate extends AbstractModel implements IdentityInterface
{
    const CACHE_TAG = 'kahanit_carrier_table_rate';
    protected $_cacheTag = 'kahanit_carrier_table_rate';
    protected $_eventPrefix = 'kahanit_carrier_table_rate';
    /* table columns */
    const ID_CARRIER_TABLE_RATE = 'id_carrier_table_rate';
    const ID_SHOP = 'id_shop';
    const ID_CARRIER = 'id_carrier';
    const ID_ZONE = 'id_zone';
    const ID_COUNTRY = 'id_country';
    const ID_STATE = 'id_state';
    const DEST_CITY = 'dest_city';
    const DEST_ZIP = 'dest_zip';
    const CONDITION_WEIGHT_FROM = 'condition_weight_from';
    const CONDITION_WEIGHT_TO = 'condition_weight_to';
    const CONDITION_PRICE_FROM = 'condition_price_from';
    const CONDITION_PRICE_TO = 'condition_price_to';
    const CONDITION_PTPRICE_FROM = 'condition_ptprice_from';
    const CONDITION_PTPRICE_TO = 'condition_ptprice_to';
    const CONDITION_QUANTITY_FROM = 'condition_quantity_from';
    const CONDITION_QUANTITY_TO = 'condition_quantity_to';
    const CONDITION_VOLUME_FROM = 'condition_volume_from';
    const CONDITION_VOLUME_TO = 'condition_volume_to';
    const PRICE = 'price';
    const COMMENT = 'comment';
    const ACTIVE = 'active';
    const ORDER = 'order';

    protected function _construct()
    {
        $this->_init('Kahanit\TableRateShipping\Model\ResourceModel\CarrierTableRate');
    }

    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }

    public function getId()
    {
        if (!is_numeric($this->getData(self::ID_CARRIER_TABLE_RATE))) {
            return $this->getData(self::ID_CARRIER_TABLE_RATE);
        }

        return (int)$this->getData(self::ID_CARRIER_TABLE_RATE);
    }

    public function getIdShop()
    {
        return (int)$this->getData(self::ID_SHOP);
    }

    public function getIdCarrier()
    {
        return (int)$this->getData(self::ID_CARRIER);
    }

    public function getIdZone()
    {
        return (int)$this->getData(self::ID_ZONE);
    }

    public function getIdCountry()
    {
        return $this->getData(self::ID_COUNTRY);
    }

    public function getIdState()
    {
        return (int)$this->getData(self::ID_STATE);
    }

    public function getDestCity()
    {
        return $this->getData(self::DEST_CITY);
    }

    public function getDestZip()
    {
        return $this->getData(self::DEST_ZIP);
    }

    public function getConditionWeightFrom()
    {
        return (float)$this->getData(self::CONDITION_WEIGHT_FROM);
    }

    public function getConditionWeightTo()
    {
        return (float)$this->getData(self::CONDITION_WEIGHT_TO);
    }

    public function getConditionPriceFrom()
    {
        return (float)$this->getData(self::CONDITION_PRICE_FROM);
    }

    public function getConditionPriceTo()
    {
        return (float)$this->getData(self::CONDITION_PRICE_TO);
    }

    public function getConditionPtpriceFrom()
    {
        return (float)$this->getData(self::CONDITION_PTPRICE_FROM);
    }

    public function getConditionPtpriceTo()
    {
        return (float)$this->getData(self::CONDITION_PTPRICE_TO);
    }

    public function getConditionQuantityFrom()
    {
        return (float)$this->getData(self::CONDITION_QUANTITY_FROM);
    }

    public function getConditionQuantityTo()
    {
        return (float)$this->getData(self::CONDITION_QUANTITY_TO);
    }

    public function getConditionVolumeFrom()
    {
        return (float)$this->getData(self::CONDITION_VOLUME_FROM);
    }

    public function getConditionVolumeTo()
    {
        return (float)$this->getData(self::CONDITION_VOLUME_TO);
    }

    public function getPrice()
    {
        return $this->getData(self::PRICE);
    }

    public function getComment()
    {
        return $this->getData(self::COMMENT);
    }

    public function getActive()
    {
        return (int)$this->getData(self::ACTIVE);
    }

    public function getOrder()
    {
        return (int)$this->getData(self::ORDER);
    }

    public function setId($id)
    {
        return $this->setData(self::ID_CARRIER_TABLE_RATE, (int)$id);
    }

    public function setIdShop($id_shop)
    {
        return $this->setData(self::ID_SHOP, (int)$id_shop);
    }

    public function setIdCarrier($id_carrier)
    {
        return $this->setData(self::ID_CARRIER, (int)$id_carrier);
    }

    public function setIdZone($id_zone)
    {
        return $this->setData(self::ID_ZONE, (int)$id_zone);
    }

    public function setIdCountry($id_country)
    {
        return $this->setData(self::ID_COUNTRY, $id_country);
    }

    public function setIdState($id_state)
    {
        return $this->setData(self::ID_STATE, (int)$id_state);
    }

    public function setDestCity($dest_city)
    {
        return $this->setData(self::DEST_CITY, $dest_city);
    }

    public function setDestZip($dest_zip)
    {
        return $this->setData(self::DEST_ZIP, $dest_zip);
    }

    public function setConditionWeightFrom($condition_weight_from)
    {
        return $this->setData(self::CONDITION_WEIGHT_FROM, (float)$condition_weight_from);
    }

    public function setConditionWeightTo($condition_weight_to)
    {
        return $this->setData(self::CONDITION_WEIGHT_TO, (float)$condition_weight_to);
    }

    public function setConditionPriceFrom($condition_price_from)
    {
        return $this->setData(self::CONDITION_PRICE_FROM, (float)$condition_price_from);
    }

    public function setConditionPriceTo($condition_price_to)
    {
        return $this->setData(self::CONDITION_PRICE_TO, (float)$condition_price_to);
    }

    public function setConditionPtpriceFrom($condition_ptprice_from)
    {
        return $this->setData(self::CONDITION_PTPRICE_FROM, (float)$condition_ptprice_from);
    }

    public function setConditionPtpriceTo($condition_ptprice_to)
    {
        return $this->setData(self::CONDITION_PTPRICE_TO, $condition_ptprice_to);
    }

    public function setConditionQuantityFrom($condition_quantity_from)
    {
        return $this->setData(self::CONDITION_QUANTITY_FROM, (float)$condition_quantity_from);
    }

    public function setConditionQuantityTo($condition_quantity_to)
    {
        return $this->setData(self::CONDITION_QUANTITY_TO, (float)$condition_quantity_to);
    }

    public function setConditionVolumeFrom($condition_volume_from)
    {
        return $this->setData(self::CONDITION_VOLUME_FROM, (float)$condition_volume_from);
    }

    public function setConditionVolumeTo($condition_volume_to)
    {
        return $this->setData(self::CONDITION_VOLUME_TO, (float)$condition_volume_to);
    }

    public function setPrice($price)
    {
        return $this->setData(self::PRICE, $price);
    }

    public function setComment($comment)
    {
        return $this->setData(self::COMMENT, $comment);
    }

    public function setActive($active)
    {
        return $this->setData(self::ACTIVE, (int)$active);
    }

    public function setOrder($order)
    {
        return $this->setData(self::ORDER, (int)$order);
    }
}
