<?php

namespace Kahanit\TableRateShipping\Model\ResourceModel;

// inheritance
use Magento\Framework\Model\ResourceModel\Db\AbstractDb;
// injection
use Magento\Framework\Model\ResourceModel\Db\Context;
// other
use Kahanit\TableRateShipping\Helper\TRSHelper;

class CarrierTableRateZone extends AbstractDb
{
    public function __construct(
        Context $context,
        $connectionName = null
    )
    {
        parent::__construct($context, $connectionName);
    }

    protected function _construct()
    {
        $this->_init('carrier_table_rate_zone', 'id_zone');
    }

    public function validateFields(\Kahanit\TableRateShipping\Model\CarrierTableRateZone $carrierTableRateZone)
    {
        // validate carrier name
        if ($carrierTableRateZone->getName() == ''
            || !preg_match('/^[^!<>;?=+@#"°{}_$%]*$/u', $carrierTableRateZone->getName())
        ) {
            return 'Invalid `Zone name`';
        }

        return (int)true;
    }

    public function getZones($id_shop, $include_default = false)
    {
        $connection = $this->getConnection();
        $sql = $connection->select();
        $sql->from($this->getMainTable(), ['*']);
        $sql->where('id_shop = ' . (int)$id_shop . (($include_default) ? ' OR id_shop = 0' : ''));

        $zones = $connection->fetchAll($sql);
        foreach ($zones as &$zone) {
            $zone['name'] = TRSHelper::stripslashes($zone['name']);
        }

        return array_merge([['id_zone' => 0, 'id_shop' => 0, 'name' => 'All Zones']], $zones);
    }

    public function getIdByName($name)
    {
        $connection = $this->getConnection();
        $sql = $connection->select();
        $sql->from($this->getMainTable(), ['id_zone']);
        $sql->where('name = \'' . TRSHelper::addslashes($name, true) . '\'');

        return $connection->fetchOne($sql);
    }
}
